/*
 * Copyright (c) 2008-2016 Haulmont.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

package com.haulmont.cuba.core.app;

import com.haulmont.chile.core.model.MetaClass;
import com.haulmont.cuba.core.entity.Entity;
import com.haulmont.cuba.core.entity.EntitySnapshot;
import com.haulmont.cuba.core.entity.diff.EntityDiff;
import com.haulmont.cuba.core.global.View;
import com.haulmont.cuba.security.entity.User;
import org.springframework.stereotype.Service;

import javax.annotation.Nullable;
import javax.inject.Inject;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.UUID;

@Service(EntitySnapshotService.NAME)
public class EntitySnapshotServiceBean implements EntitySnapshotService {

    @Inject
    protected EntitySnapshotAPI snapshotAPI;

    @Override
    public List<EntitySnapshot> getSnapshots(MetaClass metaClass, Object id) {
        return snapshotAPI.getSnapshots(metaClass, id);
    }

    @Override
    public EntitySnapshot createSnapshot(Entity entity, View view) {
        return snapshotAPI.createSnapshot(entity, view);
    }

    @Override
    public EntitySnapshot createSnapshot(Entity entity, View view, Date snapshotDate) {
        return snapshotAPI.createSnapshot(entity, view, snapshotDate);
    }

    @Override
    public EntitySnapshot createSnapshot(Entity entity, View view, Date snapshotDate, User author) {
        return snapshotAPI.createSnapshot(entity, view, snapshotDate, author);
    }

    @Override
    public Entity extractEntity(EntitySnapshot snapshot) {
        return snapshotAPI.extractEntity(snapshot);
    }

    @Override
    public EntityDiff getDifference(@Nullable EntitySnapshot first, EntitySnapshot second) {
        return snapshotAPI.getDifference(first, second);
    }

    @Override
    public void migrateSnapshots(MetaClass metaClass, Object id, Map<Class, Class> classMapping) {
        snapshotAPI.migrateSnapshots(metaClass, id, classMapping);
    }
}